/**
 * Created by wali on 2018/6/15.
 */
const apkReader = require('node-apk-parser'),
  files = require("../libs/files");

const outputInfo = (arrs = []) => {
  let len = 40, num = 0, line = '';
  arrs.forEach((d, i) => {
    num = (('|||versionCode' + d.package).replace(/[\u0391-\uFFE5]/g, "aa").length + 10);
    len = num > len ? num : len;
  });
  for (let i = 0; i < len; i++) {
    line += '-';
  }
  console.log(line);
  arrs.forEach((d, i) => {
    console.log('          dir | %s ', d.dir);
    console.log('         name | %s ', d.name);
    console.log('      package | %s ', d.package);
    console.log('  versionName | %s ', d.versionName);
    console.log('  versionCode | %s ', d.versionCode);
    console.log(line);
  });
};

const analysisApk = async (dir, isOutput) => {
  let reader = apkReader.readFile(dir),
    params = {};

  let {isFile, extname} = await files.fileInfo(dir);
  if (!isFile || extname !== '.apk') throw  new Error("file must be android apk file");

  let manifest = reader.readManifestSync();
  appliction = manifest.application || {};

  params.versionCode = manifest.versionCode;
  params.versionName = manifest.versionName;
  params.package = manifest.package;
  params.name = appliction.label;
  params.dir = dir;

  isOutput && outputInfo([params]);
  return params;
};


const analysisApks = (dirs = [], isOutput) => {
  let arrs = [];
  if (!Array.isArray(dirs))throw new Error("analysisApks.dirs must be a array!")
  if (dirs.length > 0) {
    dirs.forEach((d, i) => {
      arrs.push(analysisApk(d, isOutput));
    })
  }
  return arrs;
};

module.exports = {analysisApk, analysisApks};