const fir = require('./firs'),
  fs = require('fs'),
  files = require('../libs/files'),
  config = require('../../config/index'),
  {analysisApk} = require("../apkparse/");

let androidPath = config.oemParms[config.type].androidPath;
let succInfo = {data: []};
let errInfo = {data: []};


const uploadApks = async (infos = [], updatelog) => {
  if (infos.length <= 0) {
    files.save(androidPath + "/oem/upload_succ.list", succInfo);
    files.save(androidPath + "/oem/upload_err.list", errInfo);
    console.log("----上传结束----");
    console.log("----错误信息----");
    errInfo.data.map(d => {
      console.info(d);
    });
    console.log("--------------")

    return;
  }

  let ai = await analysisApk(infos[0].file, true);

  fir.upload({
    ...infos[0],
    apkName: ai.name,
    versionName: ai.versionName,
    versionCode: ai.versionCode,
    packageName: ai.package
  }, updatelog).then(({isok, info}) => {
    if (isok) {
      succInfo.data.push(info);
    } else {
      errInfo.data.push(info);
    }
    infos.splice(0, 1);
    uploadApks(infos, updatelog);
  });
};

const uploads = (packingCfg, updatelog = "更新成功") => {
  fs.readFile(packingCfg, 'utf8', (err, data) => {
    if (err) throw err;
    let pInfos = JSON.parse(data).data;
    console.log(pInfos);
    uploadApks(pInfos, updatelog)
  });
};

module.exports = {uploads};
