const bucket = {cb: "caibao-download", cblm: "caibao-download"},
  market = {cb: "caibao", cblm: 'caibaounion'},
  assets_bucket = {cb: "heyean-assests", cblm: "heyean-assests"},
  assets_market = {cb: "caibao/android/1", cblm: "caibaolm/android/1"},
  assets_prefix = {cb: "http://download.caibaopay.com/caibao", cblm: "http://download.caibaopay.com/caibaounion"},
  caches_dir = "./caches";

const {ossUpload} = require('./oss'),
  path = require("path"),
  files = require("../libs/files"),
  httpUtils = require("../libs/httpUtils"),
  {analysisApk} = require('../apkparse');

const uploadCaibaoOnline = file => {
  return ossUpload(bucket.cb, `${market.cb}/${path.basename(file)}`, file);
};
const updateCBMainPageDownloadUrl = file => {
  return ossUpload(bucket.cb, `${market.cb}/caibao.apk`, file);
};
const openCBUpdate4android = async ({versionCode, versionName, appDescription, updateUrl}) => {
  let info = {
    appVersionCode: versionCode,
    appVersion: versionName,
    appDescription, updateUrl
  };

  await files.save(`${caches_dir}/version.json`, info);
  console.info(info);
  return ossUpload(assets_bucket.cb, `${assets_market.cb}/version.json`, `${caches_dir}/version.json`)
};

const uploadCaibaolmOnline = file => {
  return ossUpload(bucket.cblm, `${market.cblm}/${path.basename(file)}`, file);
};
const updateCBLMMainPageDownloadUrl = file => {
  return ossUpload(bucket.cblm, `${market.cblm}/union.apk`, file);
};
const openCBLMUpdate4android = async ({versionCode, versionName, appDescription, updateUrl}) => {
  let info = {
    appVersionCode: versionCode,
    appVersion: versionName,
    appDescription, updateUrl
  };

  await files.save(`${caches_dir}/version.json`, info);
  console.info(info);
  return ossUpload(assets_bucket.cblm, `${assets_market.cblm}/version.json`, `${caches_dir}/version.json`)
};

const updateAndroid = async (file, appDescription) => {
  try {
    if ("http" === file.slice(0, 4)) {
      files.mkdirs(caches_dir);
      await httpUtils.downloadFile(`${caches_dir}/${path.basename(file)}`, file);
      file = caches_dir + '/' + path.basename(file);
    }

    let apkInfo = await analysisApk(file, true);

    if ('com.ziyuanpai.caibao' === apkInfo.package) {
      await Promise.all([uploadCaibaoOnline(file), updateCBMainPageDownloadUrl(file)]);
      await openCBUpdate4android({
        ...apkInfo,
        appDescription,
        updateUrl: `${assets_prefix.cb}/${path.basename(file)}`
      });
    } else if ('com.caibaolm' === apkInfo.package) {
      await Promise.all([uploadCaibaolmOnline(file), updateCBLMMainPageDownloadUrl(file)]);
      await openCBLMUpdate4android({
        ...apkInfo,
        appDescription,
        updateUrl: `${assets_prefix.cblm}/${path.basename(file)}`
      });
    }

    files.deleteall(caches_dir);
    console.log("update succuss");
  } catch (e) {
    console.error(e);
    files.deleteall(caches_dir)
  }
};

module.exports = {updateAndroid};