const co = require('co'),
  OSS = require('ali-oss');

const region = "oss-cn-hangzhou",
  accessKeyId = "GFqYfiIyJgNMhP2f",
  accessKeySecret = "WEcEaXoYl3ffx16QrRQW2FPwqwulrp",
  client = new OSS({
    region: region,
    accessKeyId: accessKeyId,
    accessKeySecret: accessKeySecret
  });

const osslistBuckets = () => {
  return new Promise((resolve, reject) => {
    co(function*() {
      let result = yield client.listBuckets();
      resolve(result);
    }).catch(function (err) {
      reject(err);
    });
  })
};

const ossList = options => {
  let {bucket, ...other} = options;//other 的主要参数marker（目录），prefix（文件前缀），
  return new Promise((resolve, reject) => {
    co(function*() {
      client.useBucket(bucket);
      let result = yield client.list({
        ...other
      });
      resolve(result);
    }).catch(function (err) {
      reject(err);
    });
  })
};

/**
 * 删除，但无法删除非空文件夹
 * @param bucket
 * @param files
 * @return {Promise}
 */
const ossDelete = (bucket, files = []) => {
  if (!files || !bucket)throw new Error("ossDelete 参数不能为空！");
  if (typeof files === 'string') files = [files];
  if (!Array.isArray(files)) throw new Error("ossDelete 参数files必须为String或者Array！");

  return new Promise((resolve, reject) => {
    co(function*() {
      client.useBucket(bucket);
      let result = yield client.deleteMulti(files);
      resolve(result);

    }).catch(function (err) {
      reject(err);
    });
  });
};


const ossUpload = (bucket, to, from) => {
  return new Promise((resolve, reject) => {
    co(function*() {
      client.useBucket(bucket);
      let result = yield client.put(to, from);
      resolve(result);
    }).catch(function (err) {
      reject(err);
    });
  });
};

const ossUploadByStream = (bucket, to, stream) => {
  return new Promise((resolve, reject) => {
    co(function*() {
      client.useBucket(bucket);
      let result = yield client.putStream(to, stream);
      console.log(result);
    }).catch(function (err) {
      console.log(err);
    });
  });
};


module.exports = {osslistBuckets, ossList, ossUpload, ossUploadByStream, ossDelete};